.nolist
;-----------------------------------------------------------------------------
;* Testprogramm fuer neuen ATtiny10     letzte Aenderung: 26.4.2014
;* Version: 0.0
;* Prozessor: ATtiny10
;* Schaltschema: Port B0,B1,B2 mit LEDs ueber 1k oder 470 Ohm nach GND,
;*               Port B3 blaue LED ueber 470 Ohm nach +5V verbunden
;*               tiny10test2.png
;* Autor: Rolf Pfister
;* Copyright: Freeware
;* History:
;* 26.4.2014	Erstellung
;*
;-----------------------------------------------------------------------------
.include "tn10def.inc" 	; Definitionsdatei fuer den Prozessortyp
;.include "m8def.inc"	;test to check if r0...r15 is allowed on other controllers
; Reset und Interruptvectoren	;Adr. Beschreibung
begin:	rjmp	main		; 0   Power On Reset
	reti			; 1   INT0
	reti			; 2   PCINT0
	reti			; 3   Timer0 Capture
	reti			; 4   Timer0 Overflow
	reti			; 5   Timer0 CompareA
	reti			; 6   Timer0 CompareB
	reti			; 7   Analog Comparator (ANA_COMP)
	reti			; 8   Watchdog Interrupt (WDT)
	reti			; 9   Voltage Level Monitor (VLM)
	reti			; A   ADC Conversion
;-----------------------------------------------------------------------------
; Start, Power On, Reset
.list
main:	ldi r16, low(RAMEND)
        out SPL, r16  	     ; Init Stackpointer

;; Init-Code
	ldi r16, 0x0F
        out DDRB, r16	    ; B0-B3 als Ausgaenge
        ldi r16, (1<<2)
	ldi r18, (1<<3)	    ; PB3 invertiert ansteuern
	mov r17, r16
	eor r17, r18
        out PORTB, r17      ; LED an PB2 einschalten, an PB3 aus

;; Test um CPU-Frequenz zu messen:
;t0:	inc r16			;binaer zaehlen
;	out PORTB, r16		;LEDs blinken lassen
;	rjmp t0			;diese Schlaufe braucht 4 Takte
				;gemessene Frequenz an PB0 ist also f/8

;-----------------------------------------------------------------------------
mainloop:
	rcall pause
	rol r16			;Rotiere Links
	cpi r16,0x10
;	brne t1
	brlt t1
	ldi r16, (1<<0)		;auf LED PB0 setzen
;	ldi r16, 3		;gleich 2 LEDs einschalten
t1:	mov r17, r16
	eor r17, r18		;PB3 invertiert
	out PORTB, r17		;LEDs blinken lassen
	rjmp mainloop

pause:	push r24
	push r25
	push r26
	ldi r24, 0
	ldi r25, 0
	clr r26
u1:
;	adiw r24, 1		; ungueltiger Befehl fuer Tiny10 !
				; wuerde die folgenden 3 Befehle ersetzen
	inc r24
	brne u1
	inc r25
	
	brne u1
	inc r26
	cpi r26, 2
	brne u1
	pop r26
	pop r25
	pop r24
	ret

regtests:
;.def tmp_reg=r15	;should give error
	clr r17
	mov r31, r16
	mov r32, r16		;should give error
	clr r1			;should give error
	mov r15, r16		;should give error
	ret
